Package org.kapott.hbci.manager

## Enum HHDVersion

- java.lang.Object
- - java.lang.Enum<HHDVersion>
  - - org.kapott.hbci.manager.HHDVersion

All Implemented Interfaces:
  `java.io.Serializable`, `java.lang.Comparable<HHDVersion>`

    public enum HHDVersion
    extends java.lang.Enum<HHDVersion>

Kapselt die Erkennung der verschiedenen HHD-Versionen.

### Nested Class Summary

Nested Classes
`static class` `HHDVersion.Type` Definiert die Art des TAN-Verfahrens.

### Enum Constant Summary

Enum Constants
`HHD_1_2` HHD-Version 1.2.
`HHD_1_3` HHD-Version 1.3 Zur HKTAN-Segment-Version: 1.4 ist in HKTAN4 noch nicht erlaubt, damit bleibt eigentlich nur 1.3
`HHD_1_4` HHD-Version 1.4 Zur HKTAN-Segment-Version: Genau wissen wir es nicht, aber HHD 1.4 ist wahrscheinlich.
`MS_1` Server-seitig generierter Matrix-Code (photoTAN) ZKA-Version und HKTAN-Version bleiben hier frei, weil wir anhand diesen Merkmalen das Matrix-Code-Verfahren nicht eindeutig erkennen koennen.
`QR_1_3` QR-Code in HHD-Version 1.3 - die Sparkasse verwendet das so.
`QR_1_4` QR-Code.

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`static HHDVersion` `find​(java.util.Properties secmech)` Ermittelt die zu verwendende HHD-Version aus den BPD-Informationen des TAN-Verfahrens.
`java.lang.String` `getChallengeVersion()` Liefert die Kennung fuer das Lookup in den ChallengeInfo-Daten.
`HHDVersion.Type` `getType()` Liefert die Art des TAN-Verfahrens.
`static HHDVersion` `valueOf​(java.lang.String name)` Returns the enum constant of this type with the specified name.
`static HHDVersion[]` `values()` Returns an array containing the constants of this enum type, in the order they are declared.

### Methods inherited from class java.lang.Enum

`clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

### Enum Constant Detail

#### QR_1_3

    public static final HHDVersion QR_1_3

QR-Code in HHD-Version 1.3 - die Sparkasse verwendet das so. Muss als erstes hier stehen, weil es sonst falsch als "HHD_1_3" erkannt wird (ID beginnt genauso).

#### QR_1_4

    public static final HHDVersion QR_1_4

QR-Code.

#### HHD_1_4

    public static final HHDVersion HHD_1_4

HHD-Version 1.4 Zur HKTAN-Segment-Version: Genau wissen wir es nicht, aber HHD 1.4 ist wahrscheinlich.

#### HHD_1_3

    public static final HHDVersion HHD_1_3

HHD-Version 1.3 Zur HKTAN-Segment-Version: 1.4 ist in HKTAN4 noch nicht erlaubt, damit bleibt eigentlich nur 1.3

#### MS_1

    public static final HHDVersion MS_1

Server-seitig generierter Matrix-Code (photoTAN) ZKA-Version und HKTAN-Version bleiben hier frei, weil wir anhand diesen Merkmalen das Matrix-Code-Verfahren nicht eindeutig erkennen koennen. Und da chipTAN/smsTAN deutlich gebrauechlicher ist, ist es erheblich wahrscheinlicher, dass dann nicht Matrix-Code ist. Generell unterstuetzen wir nur server-seitig generierte Matrix-Codes.

#### HHD_1_2

    public static final HHDVersion HHD_1_2

HHD-Version 1.2. Fallback.

### Method Detail

#### values

    public static HHDVersion[] values()

Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

    for (HHDVersion c : HHDVersion.values())
        System.out.println(c);

Returns:
  an array containing the constants of this enum type, in the order they are declared

#### valueOf

    public static HHDVersion valueOf​(java.lang.String name)

Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
  `java.lang.NullPointerException` - if the argument is null

#### getChallengeVersion

    public java.lang.String getChallengeVersion()

Liefert die Kennung fuer das Lookup in den ChallengeInfo-Daten.

Returns:
  die Kennung fuer das Lookup in den ChallengeInfo-Daten.

#### getType

    public HHDVersion.Type getType()

Liefert die Art des TAN-Verfahrens.

Returns:
  die Art des TAN-Verfahrens.

#### find

    public static HHDVersion find​(java.util.Properties secmech)

Ermittelt die zu verwendende HHD-Version aus den BPD-Informationen des TAN-Verfahrens.

Parameters:
  `secmech` - die BPD-Informationen zum TAN-Verfahren.
Returns:
  die HHD-Version.